#       _HEADER_.bash
#

$$

#       Copyright 2011 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       This file is part of zenpakt

#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

#======================
# global configuration
#======================

#turn on extended globbing
shopt -s extglob

#set PWD
unset PWD || return 1
cd ./ || return 1

#we want bash specific behaviour
set +o posix

#We want default pathname expansion behaviour
unset GLOBIGNORE

#the name of script sourcing this file
ZP_NAME=${0##*/}

#ZP_LOG=0           ####for future use

#set the directory to search for usage files
ZENPAKT_USAGE_DIR=$ZENPAKT_SOURCE/usage

#make sure the path is sane; in USERPATH the : is appended only when USERPATH is
#set.We assume user knows what he is doing while using USERPATH because having a
#file called cp may break scripts completely unless it is
#intended that that cp be used instead
#DEFAULTPATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
#export PATH=${USERPATH/%@(|:)/:}$DEFAULTPATH

#for sorts and greps ; making them reliable
export LC_ALL=C

#default output mode is verbose ; can be changed by configuration or sourcing
#script ;primarily used by print and spin family of functions

VERBOSE=1

ZP_SPIN_STYLE=4          #default spin style

ZP_HEADER_LINES=0                                                   #set by zp_header() , every time it is called
ZP_LOG_FILE=
zp_ask_init=0


#sparse array of backgrounded jobs' pid for future use by calling scripts
#the indices if set refers to bg pid that have not yet been killed and a trap should attempt too kill it
#each script would then just call zp_kill_bg to kill all bg processes if running
#before exiting
#zp_bg_pid=()

#zp_INT_cmd=()                                                      #array containing simple commands that should be executed in case of SIGINT
#zp_TERM_cmd=()
#zp_EXIT_cmd=()
#zp_SIG_cmd=()

#an array containing fds currently being used
#this is to be used by open_fd and close_fd functions in future
#for better management of fds
#delare -A zp_open_fds

mkfifo="mkfifo %s"                                                  #preffered make fifo command, not used much anymore
fifo_count=                                                         #should not be set by any other process or script using mkfifo()

#ARG_OPT=(); ARG_OPTARG=() ; ARG_MASSARG=() #populated and initialized by getargs() every time it is called

#the index for this assciative array will be used to refer to temporary files and
#directories in all scripts in future
#the files or directories in here will be removed at exit
#declare -A tmpfile

#_________________COMPRESSED PACKAGE RELATED VARIABLES___________________________________

pkg_pkgtype=
pkg_urlpkg=
pkgbase= ; pkgname= ; pkgext= ; pkgdir= ; pkgcompression=
description=() ; compressed= ; uncompressed=
ADM_DIR= ; TMPDIR= ; LOCK_DIR=
scandir=
pkg_filelist=
#_________________META DATA RELATED FUNCTIONS___________________________________

meta_installedpkgname=
pkg_filelist=()
pkg_links=()
