#       zp_header.bash
#       This file is part of zenpakt
#
#       Copyright 2010 Anshul Narula aka sunny <sunny_delhi18@yahoo.com>
#
#       Zenpakt is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

$DOC

uses ZP_NAME ZP_VERSION ZP_HEADER_MESSAGE ti_line global variables
zp_header [msg index total]

$ENDDOC

$$

zp_header() {
  clear
  local n
  printf '%s' "${TERMINFO_CODES[RED]}${TERMINFO_CODES[bold]}"
  printf 'Zenpakt %s-Zenwalk Package Tools %s (version:%s)%n' "$ZP_NAME" "$ZP_NAME" "$ZP_VERSION" n

  while ((n > COLUMNS));do
    ((n-=COLUMNS, ZP_HEADER_LINES+=1))
  done

  if ((n)) ;then
    printf '%*s%s\n' $((COLUMNS-n)) "" "${TERMINFO_CODES[restore]}"
    ((ZP_HEADER_LINES+=1))
  fi
  if ((($# == 3)?(${2:-0} != ${3:-0}):0)) ; then
    local current=$2
    if ((current=current*COLUMNS/$3)) ; then
      #printf "%s\n" "$ti_fg_cyan$ti_bold${ti_line:0:current}$ti_restore${ti_line:current}"
       printf '%s\n' "${TERMINFO_CODES[reverse]}($1:$(($2+1))/$3)${TERMINFO_CODES[restore]}${TERMINFO_CODES[cyan]}${TERMINFO_CODES[bold]}"
       putline -nl $current
       printf '%s' "${TERMINFO_CODES[restore]}${TERMINFO_CODES[bold]}"
       putline -l $((COLUMNS-current))
       printf '%s' "${TERMINFO_CODES[CYAN]}${TERMINFO_CODES[cyan]}"
       putline -nl $current
       printf '%s' "${TERMINFO_CODES[restore]}${TERMINFO_CODES[bold]}"
       putline -l $((COLUMNS-current))
       printf '%s' "${TERMINFO_CODES[restore]}"
       ((ZP_HEADER_LINES+=3))
    else
      printf '%s\n' "${TERMINFO_CODES[reverse]}($1:$(($2+1))/$3)${TERMINFO_CODES[restore]}"
	    putline
	    putline
	    ((ZP_HEADER_LINES+=3))
	  fi
  elif ((${2:-0} == ${3:-1})) ; then
     #printf "%s\n" "$ti_fg_cyan$ti_bold${ti_line:0:current}$ti_restore${ti_line:current}"
       printf '%s\n' "${TERMINFO_CODES[reverse]}($1:$2/$3)done${TERMINFO_CODES[restore]}${TERMINFO_CODES[cyan]}${TERMINFO_CODES[bold]}"
       #printf '%s' "${TERMINFO_CODES[cyan]}${TERMINFO_CODES[bold]}"
       putline
       printf '%s' "${TERMINFO_CODES[CYAN]}${TERMINFO_CODES[cyan]}"
       putline
       printf '%s' "${TERMINFO_CODES[restore]}"
       ZP_HEADER_LINES=3
  else
     printf "%s\n" "${TERMINFO_CODES[bold]}${ti_line}${TERMINFO_CODES[restore]}"
     ZP_HEADER_LINES=2
  fi
    #tput csr $ZP_HEADER_LINES $LINES  #change scrollable region if allowed , so that header is displayed all the time
}  2>/dev/null
